class IFS {
  PImage img;
  float[][] p_add;
  float[][] p_mul;
  
  IFS(int w, int h) {
    img = createImage(w, h, RGB);
  }
  
  void setParameters(float[][] p1, float[][] p2) {
    p_add = p1;
    p_mul = p2;
  }
  
  void iterate() {
    PImage tmp = createImage(img.width, img.height, RGB);
    int x = p_add.length;
    int y = p_add[0].length;
    int w = img.width/x;
    int h = img.height/y;
    PImage img2 = img.get();
    img2.resize(w,h);
    for(int i = 0; i < x; i++) {
      for(int j = 0; j < y; j++) {
        PImage tmpij = mul(img2, p_mul[i][j]);
        tmp.copy(add(tmpij, p_add[i][j]),
          0, 0, w, h,
          i*w, j*h, w, h);
      }
    }
    img = tmp;
  }
  
  PImage getImage() {
    return img;
  }
  
  private PImage add(PImage img, float n) {
    PImage tmp = img.get();
    for(int i=0; i < img.pixels.length; i++) {
      tmp.pixels[i] = color(blue(img.pixels[i]) + n) ;
    }
    return tmp;
  }

  private PImage mul(PImage img, float n) {
    PImage tmp = img.get();
    for(int i=0; i < img.pixels.length; i++) {
      tmp.pixels[i] = color(blue(img.pixels[i]) * n);
    }
    return tmp;
  }
}
